/*------------------------------------------------------------------------
                                /\
                             __/__\__
                            /\      /\
                           /  \    /  \ 
                          /    \  /    \
                         /______\/______\
                          /____________\
                          M   M OOOO X  X
                          M M M 0  0  XX
                          M   M OOOO X  X
 
          MOX - Centro de Computacion Avanzada en Ingenieria.
                        Facultad de Ingenieria
                       Universidad de los Andes
                         Bogota, Colombia.
------------------------------------------------------------------------*/
/*************************************************************************
  Nombre:      dxfids.h  Version: 0.5                   Fecha: Abril-1996
 -------------------------------------------------------------------------
  Descripcion: Tipo enumerado con la lista de grupos definidos para el       
               un archivo de formato dxf.      
  Tipos:       gr_id_DXF                               
  Funciones:  
  Observaciones:  

 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Autor: Daniel Barrero                                  Fecha: Abril-1996 
**************************************************************************/
#ifndef __DXF_IDS_H__
#define __DXF_IDS_H__


typedef enum { START         = 0, 
	       TEXT          = 1, 
	       NAME0         = 2, 
	       NAME1         = 3, 
	       NAMEN         = 4,
	       ENTITY_HANDLE = 5,
	       LINE_TYPE     = 6,
	       TEXT_STYLE    = 7,
	       LAYER_NAME    = 8,
	       VAR_NAME      = 9,
	       X0            = 10,
	       X1            = 11,
	       X2            = 12,
	       X3            = 13,
	       X4            = 14,
	       X5            = 15,
	       X6            = 16,
	       X7            = 17,
	       XN            = 18,
	       Y0            = 20,
	       Y1            = 21,
	       Y2            = 22,
	       Y3            = 23,
	       Y4            = 24,
	       Y5            = 25,
	       Y6            = 26,
	       Y7            = 27,
	       YN            = 28,
	       Z0            = 30,
	       Z1            = 31,
	       Z2            = 32,
	       Z3            = 33,
	       Z4            = 34,
	       Z5            = 35,
	       Z6            = 36,
	       ZN            = 37,
	       ELEVATION     = 38,
	       THICKNESS     = 39,
	       FLOATVAL0     = 40,
	       FLOATVAL1     = 41,
	       FLOATVAL2     = 42,
	       FLOATVAL3     = 43,
	       FLOATVAL4     = 44,
	       FLOATVAL5     = 45,
	       FLOATVAL6     = 47,
	       FLOATVAL7     = 47,
	       FLOATVALN     = 48,
	       REPEAT        = 49,
	       ANG0          = 50,  
	       ANG1          = 51,  
	       ANG2          = 52,  
	       ANG3          = 53,  
	       ANG4          = 54,  
	       ANG5          = 55,  
	       ANG6          = 56, 
	       ANG7          = 57, 
	       ANGN          = 58, 
	       COLORNUM      = 62,
	       ENTITIES      = 66,
	       ENT_SPAC      = 67,
	       VIEWPORT_STATE= 68,
	       VIEWPORT_ID   = 69,
	       FLAGS70      = 70,
	       FLAGS71      = 71,
	       FLAGS72      = 72,
	       FLAGS73      = 73,
	       FLAGS74      = 74,
	       FLAGS75      = 75,
	       FLAGS76      = 76,
	       FLAGS77      = 77,
	       FLAGS7N      = 78,
	       EXTRUC_DIR_X = 210,
	       EXTRUC_DIR_Y = 210,
	       EXTRUC_DIR_Z = 210,
               COMMENT       = 999, 
               STRING        = 1000,
               REG_AP_NAME   = 1001,
               EXT_ENTITIE_ST= 1002,  /*   puede ser { o } */
               EXT_ENTITIE_X_CORD = 1010,
               EXT_ENTITIE_Y_CORD = 1020,
               EXT_ENTITIE_Z_CORD = 1030,
               EXT_ENTITIE_X_POS  = 1011,
               EXT_ENTITIE_Y_POS  = 1021,
               EXT_ENTITIE_Z_POS  = 1031,
               EXT_ENTITIE_X_DISP = 1012,
               EXT_ENTITIE_Y_DISP = 1022,
               EXT_ENTITIE_Z_DISP = 1032,
               EXT_ENTITIE_X_DIR  = 1013,
               EXT_ENTITIE_Y_DIR  = 1023,
               EXT_ENTITIE_Z_DIR  = 1033,
               EXT_ENTITIE_FLOAT  = 1040,
               EXT_ENTITIE_DIST   = 1041,
               EXT_ENTITIE_SCALE  = 1042,
               EXT_ENTITIE_16INT  = 1070,
               EXT_ENTITIE_32LONG = 1071,
               DXF_FILE           = 9999
} DXF_gr_id;
 

#endif __DXF_IDS_H__
