/*------------------------------------------------------------------------
                                /\
                             __/__\__
                            /\      /\
                           /  \    /  \ 
                          /    \  /    \
                         /______\/______\
                          /____________\
                          M   M OOOO X  X
                          M M M 0  0  XX
                          M   M OOOO X  X
 
          MOX - Centro de Computacion Avanzada en Ingenieria.
                        Facultad de Ingenieria
                       Universidad de los Andes
                         Bogota, Colombia.
------------------------------------------------------------------------*/
/*************************************************************************
  Nombre:   dxftokens.h  Version: 0.5                   Fecha: Abril-1996
 -------------------------------------------------------------------------
  Descripcion: Rutinas para leer tokens de un archivo DXF (parejas de         
               lineas primera es el grupo la segunda el token..
  Tipos:       DXF_token                                
  Funciones:   
  Observaciones:  

 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Autor: Daniel Barrero                                  Fecha: Abril-1996 
**************************************************************************/

#ifndef __DXF_TOKENS_H__
#define __DXF_TOKENS_H__
#include <stdio.h>
#include <string.h> 
#include "common3d.h" 
#include "dxfids.h"
#include "extrafuncs.h"

/*------------------ Object DXF_token ----------------------------------*/
/*-----------------------------------------------------------------------
   Nombre: DXF_token        Version 0.5                Fecha: Abril-1996
   Descripcion:
     AHHHHHH.....................
   Observaciones:
   Autor: Daniel Barrero                                      Abril-1996
 -----------------------------------------------------------------------*/
typedef struct DXF_token_s {
   DXF_gr_id gr_id;      /* Group ID */
   char * data;          /* Token Data */
   int datalen;          /* lenght of data */
} DXF_token; 

DXF_token * newTokenDXF( DXF_gr_id gr_id, char * data, int datalen);
DXF_token * deleteTokenDXF( DXF_token * tok);
DXF_token * readTokenDXF (FILE * fp);
DXF_token * writeTokenDXF (FILE *fp, DXF_token * tok);
/*-----
  char eqTokenDXF(DXF_token *tok1,DXF_token *tok2) returns:
           FALSE if tok1!=tok2
             FALSE if tok1!=tok2
           TRUE || TOK_EQ if tok1.data==tok2.data && tok1.gr_id==tok2.gr_id
           TOK_GR_EQ      if tok1.gr_id==tok2.gr_id
           TOK_DATA_EQ    if tok1.data==tok2.data 
-----*/
#define TOK_EQ      1
#define TOK_GR_EQ   2
#define TOK_DATA_EQ 3
char eqTokenDXF(DXF_token *tok1,DXF_token *tok2);
/*----------------------------------------------------------------------*/
#endif __DXF_TOKENS_H__
