/*------------------------------------------------------------------------
                                /\
                             __/__\__
                            /\      /\
                           /  \    /  \ 
                          /    \  /    \
                         /______\/______\
                          /____________\
                          M   M OOOO X  X
                          M M M 0  0  XX
                          M   M OOOO X  X
 
          MOX - Centro de Computacion Avanzada en Ingenieria.
                        Facultad de Ingenieria
                       Universidad de los Andes
                         Bogota, Colombia.
------------------------------------------------------------------------*/

/*************************************************************************
  Nombre:  parsefuncs.h  Version: 0.6                   Fecha: Abril-1996
 -------------------------------------------------------------------------
  Descripcion: Rutinas para procesar cada uno de los tokens de un archivo 
               DXF                             
  Tipos:       DXF_file ( filename, file_handle, ....).
  Funciones:  
  Observaciones: las funciones deben ser de la forma:
                 char func_name(DXF_file *, DXF_rule *, DXF_token *)
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Autor: Daniel Barrero                                  Fecha: Abril-1996 
**************************************************************************/
#ifndef __PARSEFUNCS_H__
#define __PARSEFUNCS_H__
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "extrafuncs.h"
#include "libdxf.h"
#include "parsefuncs.h"

char parseDXFfile(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);
char parseDXFHEADER(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);
char parseDXFENTITIES(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);
char parseDXFBLOCKS(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);
char parseDXF3DFACE(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);
char parseDXFXVALS(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);
char parseDXFYVALS(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);
char parseDXFZVALS(DXF_file *dxf, DXF_rule *rule, DXF_token *tok);

#endif  __PARSEFUNCS_H__
