/*------------------------------------------------------------------------
                                /\
                             __/__\__
                            /\      /\
                           /  \    /  \ 
                          /    \  /    \
                         /______\/______\
                          /____________\
                          M   M OOOO X  X
                          M M M 0  0  XX
                          M   M OOOO X  X
 
          MOX - Centro de Computacion Avanzada en Ingenieria.
                        Facultad de Ingenieria
                       Universidad de los Andes
                         Bogota, Colombia.
------------------------------------------------------------------------*/
/*************************************************************************
  Nombre:   glxviewdxf    Version: 0.5                   Fecha: Abril-1996
 -------------------------------------------------------------------------
  Descripcion: Programa de prueba  de libdxf y polimeshes muestra las     
               mallas de poligonos construidas a partir de un  DXF        
  Tipos:       
  Funciones:   
  Observaciones:  Requiere OpenGL o MesaGL, y libdxf

 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Autor: Daniel Barrero                                  Fecha: Abril-1996 
**************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "gltk.h"
#include "libdxf.h"

#ifndef PI
#define PI 3.141592654
#endif PI
#define	BLACK 0
#define	GRAY 128
#define	WHITE 255
#define RD 0xA4,0x00,0x00,0xFF
#define WT 0xFF,0xFF,0xFF,0xFF
#define	brickImageWidth 16
#define	brickImageHeight 16
typedef struct { FPOINT min;
                 FPOINT max;
               } AxisMinMax;
static AxisMinMax Axis;
static int Width,Height; 

GLenum rgb, doubleBuffer, directRender;

float black[3] = {
    0.0, 0.0, 0.0
};
float blue[3] =  {
    0.0, 0.0, 1.0
};
float gray[3] =  {
    0.5, 0.5, 0.5
};
float white[3] = {
    1.0, 1.0, 1.0
};

GLenum doDither = GL_TRUE;
GLenum shade = GL_TRUE;
GLenum texture = GL_TRUE;

float xRotation = 30.0, yRotation = 30.0, zRotation = 0.0;
float xTranslation= 0 , yTranslation = 0, zTranslation= 0,xinc=0.1,yinc=0.1,zinc=0.1;
GLint orientation = GLU_OUTSIDE;

GLubyte brickImage[4*brickImageWidth*brickImageHeight] = {
    RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD,
    RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD,
    RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD,
    RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD,
    WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT,
    RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD,
    RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD,
    RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD,
    RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD, RD,
    WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT,
    RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD,
    RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD,
    RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD,
    RD, RD, RD, RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD,
    WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT, WT,
    RD, RD, RD, RD, WT, RD, RD, RD, RD, RD, RD, RD, RD, RD, WT, RD
};

char *texFileName = 0;
char *DXFFileName = NULL;
DXF_file * dxf;    

void printUsage() 
{
 printf("glxviewdxf - DXF file Viewer via GL by Daniel Barrero\n");
 printf("              e-mail:d-barrero@argos.uniandes.edu.co\n");
 printf("MOX - Centro de Computacion Avanzada en Ingenieria.\n");
 printf("\nUsage:\n");
 printf("  glxviewdxf -f filename [-rgb] [-ci] [-sb] [-sb] [-dr] [-ir] [-t filename]\n");
 printf("  - RGBA/CI (RGBA default), SB/DB (DB default), DR/ID (ID default).\n");
 printf("  - cmd line options explained:\n");
 printf("     -rgb            RGBA mode.\n");
 printf("     -ci             Color index mode.\n");
 printf("     -sb             Single buffer mode.\n");
 printf("     -db             Double buffer mode.\n");
 printf("     -dr             Direct render mode.\n");
 printf("     -ir             Indirect render mode.\n");
 printf("     -t <file name>  texture file.\n");
 printf("     -f <file name>  DXF file (Must exist always)\n");

}
void ErrorHandler(GLenum which)
{

    fprintf(stderr, "PolyMesh  Error: %s\n", gluErrorString(which));
}

#define DXF_FILE_LIST    1000
/*
   toma la escena con mallas de poligonos y crea listas de visualizacion 
   OpenGL 
*/

char createGLlist(DXF_file * dxf)
{
 int i,j,k,l;
 Point3D *v1,*v2;
 PolyMeshObj * pmesh;
 Polygon * pol;
 v1=newPoint3D(1,0,0);
 v2=newPoint3D(0,1,0);
 glEnable(GL_NORMALIZE);
 if(dxf==NULL)
   return FALSE
 ;
/* Crear listas de visualizacion de opengl desde los polymeshes */ 
 if(dxf->objects==NULL || (dxf->objects!=NULL && dxf->objects->num_objects<=0))
   return FALSE
 ;
 for(i=DXF_FILE_LIST+1,j=0 ;j<dxf->objects->num_objects;i++,j++) { 
    glNewList(i,GL_COMPILE);
       pmesh=dxf->objects->objects[j];
       if(pmesh!=NULL) {
          for(k=0;k<pmesh->num_polygons; k ++) {
             pol=pmesh->polygons[k];
             if(pol!=NULL && pol->num_points>0) {
               glBegin(GL_POLYGON); 
                  for(l=0;l<pol->num_points; l++){
          if(l==0 || (l>0 && pol->points.refs[l]!=pol->points.refs[l-1]))
                     glVertex3d(pol->points.refs[l]->x,pol->points.refs[l]->y,
                                pol->points.refs[l]->z);
                     glTexCoord3d(pol->points.refs[l]->x,pol->points.refs[l]->y,
                                pol->points.refs[l]->z);
                     
/*glTexCoord2d(pol->points.refs[l]->x,pol->points.refs[l]->y);*/
                  }
                  if(pol->num_points>=3) { 
                    copyPoint3D(v1,pol->points.refs[2]);
                    copyPoint3D(v2,pol->points.refs[1]);
                    subPoint3D(v1,pol->points.refs[0]);
                    subPoint3D(v2,pol->points.refs[0]);
                  glNormal3d(v1->y *(v2->z)-v1->z*(v2->y),-v1->x*(v2->z)+v1->z*(v2->x),
                             v1->x*(v2->y)-v1->y*(v2->x));
                 }
                 glEnd(); 
             }
          }
       } 
    glEndList(); 
 } 
 glNewList(DXF_FILE_LIST,GL_COMPILE);
    for(i=DXF_FILE_LIST+1,j=0; j<dxf->objects->num_objects;i++,j++)
       glCallList(i)
    ;
 glEndList(); 
 deletePoint3D(v1);
 deletePoint3D(v2);
 return TRUE;
}    
/* 
 toma la malla de poligonos y la pinta en OpenGL sin guardar la lista de
   visualizacion 
*/    

char meshtogl(DXF_file * dxf)
{
 int i,j,k,l;
 PolyMeshObj * pmesh;
 Polygon * pol;
 if(dxf==NULL)
   return FALSE
 ;
/* Crear listas de visualizacion de opengl desde los polymeshes */ 
 if(dxf->objects==NULL || (dxf->objects!=NULL && dxf->objects->num_objects<=0))
   return FALSE
 ;
 for(i=DXF_FILE_LIST+1,j=0 ;j<dxf->objects->num_objects;i++,j++) { 
       pmesh=dxf->objects->objects[j];
       if(pmesh!=NULL) {
          for(k=0;k<pmesh->num_polygons; k ++) {
             pol=pmesh->polygons[k];
             if(pol!=NULL) {
               glBegin(GL_POLYGON);
                  for(l=0;l<pol->num_points; l++) { 
                     glVertex3f(pol->points.refs[l]->x,pol->points.refs[l]->y,
                                pol->points.refs[l]->z);
                  }
               glEnd();
             }
          }
       } 
 } 

 return TRUE;
}    

static void Init(void)
{
  Point3D *po,*pf;
    static GLint colorIndexes[3] = {0, 200, 255};
    static float ambient[] = {0.1, 0.1, 0.1, 1.0};
    static float ambient1[] = {0.1, 0.1, 0.1, 1.0};
    static float diffuse[] = {0.5, 1.0, 1.0, 1.0};
    static float diffuse1[] = {0.5, 1.0, 1.0, 1.0};
    static float position[] = {00.0,00.0, 20.0, 0.0};
    static float position1[] = {00.0,000.0,  -20.0, 0.0};
    static float front_mat_shininess[] = {60.0};
    static float front_mat_specular[] = {0.2, 0.2, 0.2, 1.0};
    static float front_mat_diffuse[] = {0.5, 0.28, 0.38, 1.0};
    static float back_mat_shininess[] = {60.0};
    static float back_mat_specular[] = {0.5, 0.5, 0.2, 1.0};
    static float back_mat_diffuse[] = {1.0, 1.0, 0.2, 1.0};
    static float lmodel_ambient[] = {1.0, 1.0, 1.0, 1.0};
    static float lmodel_twoside[] = {GL_FALSE};
    static float decal[] = {GL_DECAL};
    static float repeat[] = {GL_REPEAT};
    static float nearest[] = {GL_NEAREST};
    TK_RGBImageRec *image;

    if (!rgb) {
	tkSetGreyRamp();
    }
    glClearColor(0.0, 0.0, 0.0, 0.0);
    
    glEnable(GL_DEPTH_TEST);

    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
    glLightfv(GL_LIGHT1, GL_AMBIENT, ambient1);
    glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse1);
    glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
    glLightModelfv(GL_LIGHT_MODEL_TWO_SIDE, lmodel_twoside);
/*
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_LIGHT1);
*/

    glMaterialfv(GL_FRONT, GL_SHININESS, front_mat_shininess);
    glMaterialfv(GL_FRONT, GL_SPECULAR, front_mat_specular);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, front_mat_diffuse);
    glMaterialfv(GL_BACK, GL_SHININESS, back_mat_shininess);
    glMaterialfv(GL_BACK, GL_SPECULAR, back_mat_specular);
    glMaterialfv(GL_BACK, GL_DIFFUSE, back_mat_diffuse);
    if (!rgb) {
	glMaterialiv( GL_FRONT_AND_BACK, GL_COLOR_INDEXES, colorIndexes);
    }

    glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, decal);
    glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, repeat);
    glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, repeat);
    glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, nearest);
    glTexParameterfv(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, nearest);
    if (texFileName) {
	image = tkRGBImageLoad(texFileName);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, image->sizeX, image->sizeY,
			  GL_RGB, GL_UNSIGNED_BYTE, image->data);
    } else {
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glTexImage2D(GL_TEXTURE_2D, 0, 4, brickImageWidth, brickImageHeight,
		     0, GL_RGBA, GL_UNSIGNED_BYTE, (GLvoid *)brickImage);
    }


/*---------------------
 llamar a la funcion encargada de crear la lista de poligonos de GL despues de
leer el DXF 
-----------------------*/
      dxf=newDXF(DXFFileName,DXF_TEXT);
      if( readDXF(dxf) !=NULL) {
/*        Cree listas de visualizacion   y encuentre el minmax */
         po=minSceneObj(dxf->objects);
         pf=maxSceneObj(dxf->objects);
         if(po==NULL || pf==NULL || eqPoint3D(po,pf) || !createGLlist(dxf)) {
           deletePoint3D(po); 
           deletePoint3D(pf); 
           deleteDXF(dxf);
           printf("Error: Unable to construct a valid Scene...\n\n");
           tkQuit();
         }
         Axis.min = (po->x<po->y && po->x<po->z)?po->x:((po->y<po->x && po->y<po->z)?po->y:po->z);
         Axis.max = (pf->x>pf->y && pf->x>pf->z)?pf->x:((pf->y>pf->x && pf->y>pf->z)?pf->y:pf->z);
         printf("min: %f  max: %f\n",Axis.min,Axis.max);
         position[0]=position[1]=0.0;
         position[1]=Axis.max*2;
         position1[0]=position1[1]=0.0;
         position[1]=-Axis.max*2;
         Axis.min*=1.3;
         Axis.max*=1.3;
         xinc=FABS(pf->x-po->x)/50;
         yinc=FABS(pf->y-po->y)/50;
         zinc=FABS(pf->z-po->z)/50;

         deleteDXF(dxf);
         deletePoint3D(po); 
         deletePoint3D(pf); 
          
         glLightfv(GL_LIGHT0, GL_POSITION, position);
         glLightfv(GL_LIGHT1, GL_POSITION, position1);
         glEnable(GL_LIGHT0);
         glEnable(GL_LIGHT1);
         glEnable(GL_LIGHTING);
      } else {
         printf("Error: Missing Filename ...\n");
         printUsage();
         deleteDXF(dxf);
	 tkQuit();
      }
     
}

static void Reshape(int width, int height)
{

    float AdjY,AdjX;
    glViewport(0, 0, (GLint)width, (GLint)height);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
  Width=width;
  Height=height;
  if (width <= height) {
    AdjY = Axis.max * (GLfloat)height / (GLfloat)width;
    AdjX = Axis.min * (GLfloat)height / (GLfloat)width;
    glOrtho((-Axis.max<Axis.min)?-Axis.max:Axis.min, (Axis.max>-Axis.min)?Axis.max:-Axis.min,  
            (-AdjY<AdjX)?-AdjY:AdjX,(AdjY>-AdjX)?AdjY:-AdjX,          
            (-Axis.max<Axis.min)?-Axis.max:Axis.min, (Axis.max>-Axis.min)?Axis.max:-Axis.min); 
  }
  else {
    AdjX = Axis.max * (GLfloat)height / (GLfloat)width;
    AdjY = Axis.min * (GLfloat)height / (GLfloat)width;
    glOrtho((-AdjX<AdjY)?-AdjX:AdjY, (AdjX>-AdjY)?AdjX:-AdjY,        
            (-Axis.max<Axis.min)?-Axis.max:Axis.min, (Axis.max>-Axis.min)?Axis.max:-Axis.min,  
            (-Axis.max<Axis.min)?-Axis.max:Axis.min, (Axis.max>-Axis.min)?Axis.max:-Axis.min); 
  }

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

static GLenum Key(int key, GLenum mask)
{

    switch (key) {
      case TK_ESCAPE:
	tkQuit();

      case TK_LEFT:
	yRotation += 5;
	break;
      case TK_RIGHT:
	yRotation -= 5;
	break;
      case TK_UP:
	xRotation += 5;
	break;
      case TK_DOWN:
	xRotation -= 5;
	break;
      case TK_X:
	zRotation += 5;
	break;
      case TK_x:
	zRotation -= 5;
	break;
      case TK_j:
        xTranslation += xinc;
        break;
      case TK_J:
        xTranslation -= xinc;
        break;
      case TK_k:
        yTranslation += yinc;
        break;
      case TK_K:
        yTranslation -= yinc;
        break;
      case TK_l:
        zTranslation += zinc;
        break;
      case TK_L:
        zTranslation -= zinc;
        break;
      case TK_1:
        glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	break;
      case TK_2:
        glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	break;
      case TK_3:
        glPolygonMode(GL_FRONT_AND_BACK, GL_POINT);
	break;

      case TK_0:
	shade = !shade;
	if (shade) {
            glShadeModel(GL_SMOOTH);
	} else {
	    glShadeModel(GL_FLAT);
	}
	break;

      case TK_z:
        texture = !texture;
	if (texture) {
	    glEnable(GL_TEXTURE_2D);
	} else {
	    glDisable(GL_TEXTURE_2D);
	}
	break;
      case TK_c:
        Axis.min*=1.1;
        Axis.max*=1.1;
        Reshape(Width,Height);
        break;
      case TK_C:
        Axis.min*=0.9;
        Axis.max*=0.9;
        Reshape(Width,Height);
        break;

      case TK_q:
	glDisable(GL_CULL_FACE);
	break;
      case TK_w:
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);
	break;
      case TK_e:
	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);
	break;

      case TK_r:
	glFrontFace(GL_CW);
	break;
      case TK_t: 
	glFrontFace(GL_CCW);
	break;

      case TK_y:
	doDither = !doDither;
	(doDither) ? glEnable(GL_DITHER) : glDisable(GL_DITHER);
	break;

      default:
	return GL_FALSE;
    }
    return GL_TRUE;
}

static void Draw(void)
{

    glLoadIdentity();
    glRotatef(xRotation, 1, 0, 0);
    glRotatef(yRotation, 0, 1, 0);
    glRotatef(zRotation, 0, 0, 1);
    glTranslatef(xTranslation,yTranslation,zTranslation);

    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

/*    glColor3f(1.0, 1.0, 1.0); */
/* -------------------------------------------------*/
/* llamar lista con los poligonos de la escena  */
    glCallList(DXF_FILE_LIST);
/*meshtogl(dxf);*/
    if (doubleBuffer) {
	tkSwapBuffers();
    }
}

static GLenum Args(int argc, char **argv)
{
    GLint i;

    rgb = GL_TRUE;
    doubleBuffer = GL_TRUE;
    directRender = GL_FALSE;

    for (i = 1; i < argc; i++) {
	if (strcmp(argv[i], "-ci") == 0) {
	    rgb = GL_FALSE;
	} else if (strcmp(argv[i], "-rgb") == 0) {
	    rgb = GL_TRUE;
	} else if (strcmp(argv[i], "-sb") == 0) {
	    doubleBuffer = GL_FALSE;
	} else if (strcmp(argv[i], "-db") == 0) {
	    doubleBuffer = GL_TRUE;
	} else if (strcmp(argv[i], "-dr") == 0) {
	    directRender = GL_TRUE;
	} else if (strcmp(argv[i], "-ir") == 0) {
	    directRender = GL_FALSE;
	} else if (strcmp(argv[i], "-f") == 0) {
	    if (i+1 >= argc || argv[i+1][0] == '-') {
		printf("Error: -f (No file name).\n");
		return GL_FALSE;
	    } else {
		DXFFileName = argv[++i];
	    }
	} else if (strcmp(argv[i], "-t") == 0) {
	    if (i+1 >= argc || argv[i+1][0] == '-') {
		printf("Error: -t (No file name).\n");
		return GL_FALSE;
	    } else {
		texFileName = argv[++i];
	    }
	} else {
	    printf("Error: %s (Bad option).\n\n", argv[i]);
            printUsage();
	    return GL_FALSE;
	}
    }
    if ( DXFFileName == NULL ) {
         printf("Error: Missing Filename ...\n\n");
         printUsage();
         return GL_FALSE;
    }
    return GL_TRUE;
}

void main(int argc, char **argv)
{
    GLenum type;

    if (Args(argc, argv) == GL_FALSE) {
	tkQuit();
    }

    tkInitPosition(0, 0, 300, 300);

    type = TK_DEPTH;
    type |= (rgb) ? TK_RGB : TK_INDEX;
    type |= (doubleBuffer) ? TK_DOUBLE : TK_SINGLE;
    type |= (directRender) ? TK_DIRECT : TK_INDIRECT;
    tkInitDisplayMode(type);

    if (tkInitWindow("GL - View DXF") == GL_FALSE) {
	tkQuit();
    }

    Init();

    tkExposeFunc(Reshape);
    tkReshapeFunc(Reshape);
    tkKeyDownFunc(Key);
    tkDisplayFunc(Draw);
    tkExec();
}
