/*------------------------------------------------------------------------
                                /\
                             __/__\__
                            /\      /\
                           /  \    /  \ 
                          /    \  /    \
                         /______\/______\
                          /____________\
                          M   M OOOO X  X
                          M M M 0  0  XX
                          M   M OOOO X  X
 
          MOX - Centro de Computacion Avanzada en Ingenieria.
                        Facultad de Ingenieria
                       Universidad de los Andes
                         Bogota, Colombia.
------------------------------------------------------------------------*/
/*************************************************************************
  Nombre: common3D.c      Version: 0.5                  Fecha: Abril-1996
 -------------------------------------------------------------------------
  Descripcion: 
  Tipos:       
  Funciones:   
  Observaciones:  

 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Autor: Daniel Barrero                                  Fecha: Abril-1996 
**************************************************************************/
#include <stdlib.h>
#include <string.h>
#include "common3d.h" 

/*------------------  Object Point3D -----------------------------------*/
Point3D * newPoint3D ( FPOINT x, FPOINT y, FPOINT z)
{
 Point3D *p=(Point3D *) malloc ( sizeof( Point3D) ); 
 return setPoint3D(p,x,y,z); 
}

Point3D * deletePoint3D ( Point3D * p)
{
  if(p!=NULL)         
     free (p)
  ;
  return (p=NULL);
}

Point3D *  setPoint3D(Point3D * p, FPOINT x, FPOINT y, FPOINT z)
{
 if(p!=NULL) {
    p->x=x;
    p->y=y;
    p->z=z;
 }
 return p;
}

Point3D * copyPoint3D(Point3D * p1, Point3D * p2)
{
  if(p1==NULL || p2==NULL)  
    return NULL
  ;
  return setPoint3D(p1,p2->x,p2->y,p2->z);
}

Point3D * addPoint3D ( Point3D * p1, Point3D *p2)
{
 if(p1==NULL || p2==NULL ) {
   return NULL;
 }
 return setPoint3D(p1,p1->x+p2->x,p1->y+p2->y,p1->z+p2->z); 
}

Point3D * subPoint3D ( Point3D * p1, Point3D *p2)
{
 if(p1==NULL || p2==NULL ) {
   return NULL;
 }
 return setPoint3D(p1,p1->x-p2->x,p1->y-p2->y,p1->z-p2->z);
}

Point3D * addPoint3DFPOINT ( Point3D * p, FPOINT s)
{
 return (p!=NULL)?setPoint3D(p,p->x+s,p->y+s,p->z+s):p;
}

Point3D * multPoint3DFPOINT ( Point3D * p, FPOINT f)
{
 return (p!=NULL)?setPoint3D(p,p->x*f,p->y*f,p->z*f):p;
}

/*----------------------------------------------------------------------*/
/*------------------  Object Surface  ----------------------------------*/ 
Surface * newSurface(FPOINT ambient,FPOINT diffuse, FPOINT brilliance,
                     FPOINT specular,FPOINT roughness,FPOINT reflection,
                     FPOINT refraction)
{ 
 Surface * surf;
 surf=(Surface *)malloc(sizeof(Surface));
 return setSurface(surf,ambient,diffuse,brilliance,specular, 
                   roughness,reflection,refraction);

}

Surface * deleteSurface( Surface * surf)
{
 if(surf==NULL)
   return NULL
 ;
 free(surf);
 surf=NULL;
 return surf;
}

Surface * setSurface(Surface * surf, FPOINT ambient,FPOINT diffuse,
                     FPOINT brilliance,FPOINT specular,FPOINT roughness,
                     FPOINT reflection,FPOINT refraction)
{
 if(surf==NULL)
   return NULL
 ;
 surf->ambient=ambient;
 surf->diffuse=diffuse;
 surf->brilliance=brilliance;
 surf->specular=specular;
 surf->roughness=roughness;
 surf->reflection=reflection;
 surf->refraction=refraction;
 return surf;
}

Surface * copySurface(Surface * surf1, Surface * surf2)
{
 if(surf1==NULL || surf2==NULL)  
   return NULL
 ;
 return setSurface(surf1,surf2->ambient,surf2->diffuse,surf2->brilliance,
                   surf2->specular,surf2->roughness,surf2->reflection,
                   surf2->refraction);
}


/*----------------------------------------------------------------------*/

