/*------------------------------------------------------------------------
                                /\
                             __/__\__
                            /\      /\
                           /  \    /  \ 
                          /    \  /    \
                         /______\/______\
                          /____________\
                          M   M OOOO X  X
                          M M M 0  0  XX
                          M   M OOOO X  X
 
          MOX - Centro de Computacion Avanzada en Ingenieria.
                        Facultad de Ingenieria
                       Universidad de los Andes
                         Bogota, Colombia.
------------------------------------------------------------------------*/
/*************************************************************************
  Nombre:   dxftokens.c  Version: 0.5                   Fecha: Abril-1996
 -------------------------------------------------------------------------
  Descripcion: Rutinas para leer tokens de un archivo DXF (parejas de         
               lineas primera es el grupo la segunda el token..
  Tipos:       DXF_token                                
  Funciones:   
  Observaciones:  

 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Autor: Daniel Barrero                                  Fecha: Abril-1996 
**************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "dxftokens.h"

/*------------------ Object DXF_token ----------------------------------*/
/*-----------------------------------------------------------------------
   Nombre: DXF_token        Version 0.5                Fecha: Abril-1996
   Descripcion:
     AHHHHHH.....................
   Observaciones:
   Autor: Daniel Barrero                                      Abril-1996
 -----------------------------------------------------------------------*/
DXF_token * newTokenDXF( DXF_gr_id gr_id, char * data, int datalen)
{
 DXF_token * tok = (DXF_token *) malloc(sizeof(DXF_token));
 tok->gr_id=gr_id;
 tok->data=(char *) malloc (sizeof(char)*datalen+1);
 memcpy(tok->data,data,datalen+1);
 tok->datalen=datalen;

 return tok;
}

DXF_token * deleteTokenDXF( DXF_token * tok)
{
 if(tok==NULL) 
   return NULL
 ;
 if(tok->data!=NULL) 
   free(tok->data)
 ;
 free(tok);
 tok=NULL; 

 return tok;
}

DXF_token * readTokenDXF (FILE * fp)
{
 DXF_token * tok=NULL;
 char buffer1[MAXBUFFER];
 char buffer2[MAXBUFFER]; 
 char *b1,*b2;
 for(;(b1=fgets(buffer1,MAXBUFFER,fp))!=NULL && !strcmp(b1,"\n");  )
 ;
/*
 for(;(b2=fgets(buffer2,MAXBUFFER,fp))!=NULL && !strcmp(b2,"\n");  )
 ;
*/
 b2=fgets(buffer2,MAXBUFFER,fp);
 if(b1!=NULL && b2!=NULL) { 
    _xstrupr(b1); 
    _xstrclean(b1," \t\n");
    _xstrupr(b2);
    if(strcmp(b2,"\n") )
       _xstrclean(b2," \t\n")
    ;
    tok=newTokenDXF(atoi(b1),b2,strlen(b2));
 }
/*
 if(fgets(buffer1,MAXBUFFER,fp)!=NULL && fgets(buffer2,MAXBUFFER,fp)!=NULL) {
    _xstrupr(buffer1); 
    _xstrclean(buffer1," \t\n");
    _xstrupr(buffer2);
    _xstrclean(buffer2," \t\n");
    tok=newTokenDXF(atoi(buffer1),buffer2,strlen(buffer2));
 }
*/ 
 return tok; 
}

DXF_token * writeTokenDXF (FILE *fp, DXF_token * tok)
{
 char buffer[MAXBUFFER];
 if(tok==NULL) 
   return NULL
 ;
 sprintf(buffer,"%d\n",tok->gr_id);
 if(fputs(buffer,fp)!=EOF)  {
     sprintf(buffer,"%s\n",tok->data);
     if(fputs(buffer,fp)!=EOF) 
        return tok
     ;
 }
 return NULL;
}

char eqTokenDXF(DXF_token *tok1,DXF_token *tok2)
{ 
 if(tok1 == NULL && tok2==NULL)
   return TOK_EQ
 ;
 if((tok1 == NULL && tok2 != NULL) || (tok1 != NULL && tok2 == NULL))
   return FALSE
 ;
 if(tok1->gr_id == tok1->gr_id ) {
    if (!strcmp(tok1->data,tok2->data)) {
        return TOK_EQ;
    }
    return TOK_GR_EQ;
 } else {
   if(!strcmp(tok1->data,tok2->data))
     return TOK_DATA_EQ
   ;
 }
 return FALSE;
}

/*----------------------------------------------------------------------*/
